 {$M $800,0,0}

 uses tsr,crt,dos;

 const lshift : byte = $2;
       rshift : byte = $1;
       capsl : byte = $40;
       ctrl : byte = $4;
       f12 : byte = $58;
       sloupec_m = 28;
       radek_m = 10;
       sloupcu_m = 23;
       radku_m = 4;
       max_m = 2;
       item_m : array [1..2] of string =
                ('Standardn klvesnice','esk klvesnice');
       const keys : set of byte = [$29,$2,$3,$4,$5,$6,$7,$8,$9,$A,$B,$C,$1A,
                                   $1B,$27,$28,$33,$34,$35,$15,$2C];

             keysup : set of byte = [$2A,$36,$3A,$AA,$B6,$BA];

             keys1 : set of byte = [$1E,$12,$17,$18,$13,$16,$2C];

             keys2 : set of byte = [$2E,$20,$12,$31,$13,$1F,$14,$16,$15];

 type scr_s_m = array [1..sloupcu_m] of word;
      scr_m = array [1..radku_m] of scr_s_m;


 var flag,ch,ch_m,func,curx,cury,poz_m,videomode,x1,y1,x2,y2,l1,l2 : byte;
     reg : registers;
     up,pressed,param,ext1,ext2 : boolean;
     menu_seg,menu_ofs : word;
     screen_m : ^scr_s_m;
     savescr_m : scr_m;

 procedure cursor (state : boolean);

 begin
  with reg do
   case state of
    true : begin ah := 1; ch := 12; cl := 14 end;
    false : begin ah := 1; ch := 32; cl := 0 end;
   end;
  intr ($10,reg);
 end;

 procedure box (x,y : byte);

 begin
  x1 := sloupec_m; x2 := x1 + x - 1; y1 := radek_m; y2 := y1 + y - 1;
  textbackground (3); textcolor (5); window (x1,y1,x2,y2); clrscr;
  window (x1,y1,x2 + 1,y2 + 1);
  for l1 := 2 to x - 1 do
   begin gotoxy (l1,1); write (''); gotoxy (l1,y); write (''); end;
  for l2 := 2 to y - 1 do
   begin gotoxy (1,l2); write (''); gotoxy (x,l2); write (''); end;
  gotoxy (1,1); write (''); gotoxy (x,1); write (''); gotoxy (1,y);
  write (''); gotoxy (x,y); write ('');
  textcolor (15); textbackground (1); gotoxy (2,func + 1); write (item_m[func]);
  gotoxy (2,4 - func); textcolor (0); textbackground (3); write (item_m[3 - func]);
 end;

 procedure show (on : boolean);

 begin
   for l1 := 1 to radku_m do
    begin
     screen_m := ptr (menu_seg,menu_ofs + (l1 - 1) * 160);
     if on = true then savescr_m[l1] := screen_m^
     else screen_m^ := savescr_m[l1];
    end;
 end;

 procedure menu;

 begin
  menu_ofs := ((radek_m - 1) * 80 + sloupec_m - 1) * 2;
  reg.ah := $0F; intr($10,reg); videomode := reg.al;
  case videomode of
   7 : menu_seg := $B000 + reg.bh * $2000;
   2,3 : menu_seg := $B800 + reg.bh * $2000;
  end;
  screen_m := ptr (menu_seg,menu_ofs);
  pressed := false;
  if (videomode = 7) or (videomode in [2..3]) then
   begin
    curx := wherex; cury := wherey; cursor (false); show (true);
    box (sloupcu_m,radku_m);
    repeat
     ch_m := port [$60];
     if ((ch_m = $48) or (ch_m = $50)) and (not pressed) then
      begin
       pressed := true;
       case ch_m of
        $48 : begin dec (poz_m); if poz_m = 0 then poz_m := max_m; end;
        $50 : begin inc (poz_m); if poz_m = max_m + 1 then poz_m := 1; end;
       end;
       gotoxy (2,2); textcolor (0); textbackground (3); write (item_m[1]);
       gotoxy (2,3); write (item_m[2]); gotoxy (2,poz_m + 1); textcolor (15);
       textbackground (1); write (item_m[poz_m]);
      end
     else if (ch_m = $C8) or (ch_m = $D0) then pressed := false;
    until (ch_m = $1C) or (ch_m = $1);
    window (1,1,80,25); gotoxy (curx,cury); cursor (true);
    if ch_m = $1C then func := poz_m; show (false);
   end;
 end;

 procedure keybcs;

 begin
  if (ch in keys) then
   begin
    reg.ah := $5; reg.ch := $E; reg.cl := 8; intr ($16,reg);
    reg.ah := $5; reg.ch := ch;
    if up then
     case ch of
      $29 : reg.cl := 59;
      $2 : reg.cl := 49;
      $3 : reg.cl := 50;
      $4 : reg.cl := 51;
      $5 : reg.cl := 52;
      $6 : reg.cl := 53;
      $7 : reg.cl := 54;
      $8 : reg.cl := 55;
      $9 : reg.cl := 56;
      $A : reg.cl := 57;
      $B : reg.cl := 48;
      $C : reg.cl := 37;
      $D : reg.cl := 43;
      $1A : reg.cl := 47;
      $1B : reg.cl := 40;
      $27 : reg.cl := 127;
      $28 : reg.cl := 33;
      $33 : reg.cl := 63;
      $34 : reg.cl := 58;
      $35 : reg.cl := 95;
      $15 : reg.cl := 90;
      $2C : reg.cl := 89;
     end else
     case ch of
      $29 : reg.cl := 172;
      $2 : reg.cl := 43;
      $3 : reg.cl := 136;
      $4 : reg.cl := 168;
      $5 : reg.cl := 135;
      $6 : reg.cl := 169;
      $7 : reg.cl := 145;
      $8 : reg.cl := 152;
      $9 : reg.cl := 160;
      $A : reg.cl := 161;
      $B : reg.cl := 130;
      $C : reg.cl := 61;
      $1A : reg.cl := 163;
      $1B : reg.cl := 41;
      $27 : reg.cl := 150;
      $28 : reg.cl := 173;
      $33 : reg.cl := 44;
      $34 : reg.cl := 46;
      $35 : reg.cl := 45;
      $15 : reg.cl := 122;
      $2C : reg.cl := 121;
     end;
    intr ($16,reg);
    if (ch in keys) and (ch <> $2C) then ext1 := false;
    if (ch in keys) and (ch <> $15) then ext2 := false;
   end;
  if ext1 then
   begin
    if (ch in keys1) then
     begin
      reg.ah := $5; reg.ch := $E; reg.cl := 8; intr ($16,reg);
      reg.ah := $5; reg.ch := ch;
      if up then
       case ch of
        $1E : reg.cl := 143;
        $12 : reg.cl := 144;
        $17 : reg.cl := 139;
        $18 : reg.cl := 149;
        $13 : reg.cl := 171;
        $16 : reg.cl := 151;
        $2C : reg.cl := 157;
       end else
       case ch of
        $1E : reg.cl := 160;
        $12 : reg.cl := 130;
        $17 : reg.cl := 161;
        $18 : reg.cl := 162;
        $13 : reg.cl := 170;
        $16 : reg.cl := 163;
        $2C : reg.cl := 152;
       end;
      intr ($16,reg);
     end;
    if ch in keys1 then ext1 := false;
   end;
  if ext2 then
   begin
    if (ch in keys2) then
     begin
      reg.ah := $5; reg.ch := $E; reg.cl := 8; intr ($16,reg);
      reg.ah := $5; reg.ch := ch;
      if up then
       case ch of
        $2E : reg.cl := 128;
        $20 : reg.cl := 133;
        $12 : reg.cl := 137;
        $31 : reg.cl := 165;
        $13 : reg.cl := 158;
        $1F : reg.cl := 155;
        $14 : reg.cl := 134;
        $16 : reg.cl := 166;
        $15 : reg.cl := 146;
       end else
       case ch of
        $2E : reg.cl := 135;
        $20 : reg.cl := 131;
        $12 : reg.cl := 136;
        $31 : reg.cl := 164;
        $13 : reg.cl := 169;
        $1F : reg.cl := 168;
        $14 : reg.cl := 159;
        $16 : reg.cl := 150;
        $15 : reg.cl := 145;
       end;
      intr ($16,reg);
     end;
    if ch in keys2 then ext2 := false;
   end;
  if not (ch in keysup) then begin ext1 := false; ext2 := false; end;
  if (ch = $D) then
   begin
    reg.ah := $5; reg.ch := $E; reg.cl := 8; intr ($16,reg);
   end;
  if (ch = $8D) then
   begin
    if not up then ext1 := true;
    if up then ext2 := true;
   end;
 end;

 {$F+}

 procedure ovladac;

 begin
  flag := mem[$40:$17];
  if (((lshift and flag) = lshift) or ((rshift and flag) = rshift)) xor
   ((capsl and flag) = capsl) then up := true else up := false;
  ch := port[$60];
  if (ch = f12) and ((ctrl and mem[$40:$17]) = ctrl) then
   begin
    asm pushf end; oldintprog; menu; mem[$40:$17] := mem[$40:$17] xor ctrl;
   end
  else
   begin
    asm pushf end; oldintprog;
    case func of
     2 : keybcs;
    end;
   end;
 end;

 {$F-}

begin
 if (paramstr (1) = '/o') or (paramstr (1) = '/O') then param := true;
 ident_tsr := 'KEYBCS'; func := 1; poz_m := 1;
 zavadec_tsr ($9,ovladac,false,false);
 if (not is_there) then
  begin
   if param then writeln ('Program nen rezidentn v pamti !');
   if (not param) then
    begin
     writeln (#13#10,
              'KEYBCS je rezidentn program emulujc eskou klvesnici .',#13#10,
              'Aktivuje se kombinac klves Ctrl+F12 .',#13#10,
              'Odinstalovn z pamti -> parametr /o .',#13#10#13#10,
              'Pozn.: Pro sprvnou funkci mus bt nastavena tabulka znak podle Kamenickch.',#13#10,
              '       Ppadn nastaven pomoc programu TABCS.',#13#10#13#10,
              '                                               Copyright (C) 1998 by Jan Outrata');
     zavadec_tsr ($9,ovladac,true,false);
    end;
  end;
 if is_there then
  if (paramstr (1) = '/o') or (paramstr (1) = '/O') then
   begin
    writeln (#13#10,
             'Dkuji Vm za pouit programu KEYBCS .',#13#10#13#10,
             'Jan Outrata, e-mail: outrataj@alpha.inf.upol.cz, tel.: 068/5947751',#13#10);
    zavadec_tsr ($9,ovladac,false,true);
   end
  else writeln (#13#10,'Program je ji rezidentn v pamti.');
end.